#include <avr/io.h>
#include <avr/interrupt.h>

#define	CRYSTAL_HZ	20000000L			// 20MHz̃NbNœ삵Ă܂
#define	CLOCK_SCALE	20				// ^C}荞݂̃JEg20ɂ܂
#define	INTERRUPT_COUNT	(CLOCK_SCALE * 1024)		// NbN1024ă^C}̃JEgɎgp܂
#define	WAIT_LCDCYCLE	2				// ^C}荞2񕪂̃EFCg
#define	WAIT_SHORT	10				// ^C}荞10񕪂̃EFCg
#define	outLcdCmd(cmd)	outLcd8bits(cmd, 0)		// tɃR}ht
#define	outLcdData(data)	outLcd8bits(data, 1)	// tɃf[^t


volatile int nextLcdCounter;
volatile int lcdCounter;
volatile long clockCounter;
volatile unsigned char sec = 0;
volatile unsigned char min = 0;
volatile unsigned char hour = 0;
unsigned char sregSave;

// ^C}荞݂̃nh ----------------------------------------------------
ISR (TIMER0_COMPA_vect)
{
	sregSave = SREG;	// Xe[^XWX^̑ޔ

	if (lcdCounter >= 0) {
		lcdCounter--;	// tpJE^̃JEg
	} else if ( nextLcdCounter > 0 ) {
		// tp̎̃JEgn߂
		lcdCounter = nextLcdCounter;
		nextLcdCounter = -1;
	}
	clockCounter += INTERRUPT_COUNT;	// 荞1񕪂̃NbN𑫂
	if ( clockCounter >= CRYSTAL_HZ ) {	// 1bȏo߂Ă
		clockCounter -= CRYSTAL_HZ;	// 1b̃NbN
		if ( ++sec >= 60 ) {
			sec -= 60;		// 60bo߂Ď̕ɐi
			if ( ++min >= 60 ) {
				min -= 60;	// 60o߂Ď̎Ԃɐi
				if ( ++hour >= 24 ) {
					hour -= 24;	// ^钆߂Ď߂
				}
			}
		}
	}

	SREG = sregSave;	// Xe[^XWX^̕A
}

void setTimer(int count)
{
	nextLcdCounter = count;	// tp̃JEg
}

int expiredTimer()
{
	return (nextLcdCounter < 0 && lcdCounter < 0);	// t̃JEgI𔻒f(̔菇͏dv)
}

void waitTimer(int count)
{
	// tp̃^C}[ݒ肵ďI܂ő҂
	setTimer(count);

	while (!expiredTimer())
		;	// [v̒ł͉sȂ
}

char toHexdecimal(int i)
{
	// l16i̕ɕϊ
	static char *hd = "0123456789ABCDEF";

	if (i < 0 || i > 15)
		return ' ';
	return hd[i];
}

// t֌WI/O -------------------------------------------------------
void outLcd4bits(unsigned char data, char rs)
{
	// t4bitf[^܂4bitR}h𑗂
	unsigned char outData;

	outData = ((data << 4) & 0xf0);
	if (rs)
		outData |= 0x4;	// R}h̏ꍇAΉbitONɂ
	PORTD = (outData | 0x8);	// f[^o & Enable = H
	waitTimer(WAIT_LCDCYCLE);
	PORTD = outData;	// f[^ێ & Enable = L
	waitTimer(WAIT_LCDCYCLE);
}

void outLcd8bits(unsigned char data, char rs)
{
	// 8bitf[^܂́A8bitR}h4bit~2ɕđ
	outLcd4bits(data >> 4, rs);
	outLcd4bits(data, rs);
}

void lcdInit(void)
{
	// t̏
	outLcd4bits(0x3, 0);
	waitTimer(WAIT_SHORT);
	outLcd4bits(0x3, 0);
	waitTimer(WAIT_SHORT);
	outLcd4bits(0x3, 0);
	waitTimer(WAIT_SHORT);

	outLcd4bits(0x2, 0);	// 4bit I/Os[hɐݒ肷

	outLcdCmd(0x28);	// 4bit[h2s\5x8hbgtHgI
	outLcdCmd(0x08);	// \It
	outLcdCmd(0x01);	// \NA
	outLcdCmd(0x06);	// o͂ɂJ[\ړw
	outLcdCmd(0x0c);	// \I
}

void printClock(void)
{
	outLcdCmd(0xc0);
	outLcdData('0' + (hour / 10));	// Ԃ10̌
	outLcdData('0' + (hour % 10));	// Ԃ1̌
	outLcdData(':');		// Ԃƕ̊Ԃ:
	outLcdData('0' + (min / 10));	// 10̌
	outLcdData('0' + (min % 10));	// 1̌
	outLcdData(':');		// ƕb̊Ԃ:
	outLcdData('0' + (sec / 10));	// b10̌
	outLcdData('0' + (sec % 10));	// b1̌
}

void print2ndLine(char *data)
{
	char *p;

	outLcdCmd(0xc0);		// J[\2sڐ擪
	for ( p = data; *p != '\0'; p++ ) {
		outLcdData(*p);
	}	
}

void startClock(unsigned char *data)
{
	unsigned long tm;

	cli();			// 荞݋֎~
	tm = (((unsigned long)data[40]) << 24) | (((unsigned long)data[41]) << 16) |  (((unsigned long)data[42]) << 8) | (unsigned long)data[43];	// NTPpPbgT[oo
	sec = tm % 60UL;	// b̎o
	tm /= 60UL;
	min = tm % 60UL;	// ̎o
	tm /= 60UL;
	hour = (tm + 9) % 24;	// E{
	sei();			// 荞݉
}

// vÕC ---------------------------------------------------------
extern int wifiInitialize1();
extern int wifiInitialize2();
extern int wifiInitialize3();
extern char readBuff[];

int main(void)
{
	static char msg[] = "SNTP clock";
	int i;
	unsigned char oldsec = 0xff;

	cli();			// 荞݋֎~

	// CPŮe|[g̏
	DDRB = 0xff;
	PORTB = 0;
	DDRC = 0xff;
	PORTC = 0;
	DDRD = 0xfe;
	PORTD = 0;
	wifiInitialize1();	// Wi-FiW[ɂȂI/Ȍ

	// ^C}荞݂̐ݒ
	TCCR0A = 0x02;
	TIMSK0 |= (1 << OCIE0A);
	OCR0A = (CLOCK_SCALE - 1); // 19JEg_En0ʂ߂犄荞ݎs
	TCCR0B = 0x05;		// vXP[ 1/1024 ɐݒ

	clockCounter = 0;	// 1b̃JE^
	lcdCounter = -1;	// t֌W̃JE^
	sei();			// 荞݋

	lcdInit();		// t
	wifiInitialize2();	// Wi-FiW[ƃ{[[g̒

	waitTimer(1000);	// Wi-FiW[̏1b҂
	// NbZ[Wtɕ\
	for ( i = 0; msg[i] != '\0'; i++ )
		outLcdData(msg[i]);

	if ( !wifiInitialize3() ) {
		// NTPł̎擾ɎsꍇtWi-FiW[̃G[R[h\
		outLcdCmd(0x01);
		for ( i = 0; readBuff[i] != 0; i++ ) {
			if ( readBuff[i] == 0x0d || readBuff[i] == 0x0a)
				continue;
			outLcdData(readBuff[i]);
		}
		if (readBuff[0] == 'E' &&
			readBuff[1] == 'R' &&
			readBuff[2] == 'R' &&
			readBuff[3] == 'O' &&
			readBuff[4] == 'R' ) {
			outLcdData(' ');
			outLcdData(toHexdecimal((readBuff[5]>>4)&15));
			outLcdData(toHexdecimal((readBuff[5]&15)));
		}

		return 1;
	}


	print2ndLine("                 ");	// t2sڂNA
	// C[v
	while (1) {
		if (sec != oldsec) {
			// Õ[vb̒lωĂ
			oldsec = sec;
			printClock();	// tɕ\
		}
	}
}
