#include <avr/io.h>
#include <avr/interrupt.h>
#include "private.h"

#define	BUFF_LEN	128			// ꎞf[^̈̃TCY
#define	UDP_BUFF_LEN	48			// SNTPpPbg
#define	TRUE		(-1)			// _l̐^
#define	FALSE		0			// _l̋U
#define	CR		'\r'			// AR[h
#define	LF		'\n'			// sR[h
#define	NTP_SERVER	"133.243.238.163"	// ntp.nict.jp IPAhX
//#define	NTP_SERVER	"202.224.32.4"	// ntp.asahi-net.or.jp IPAhX
#define	NTP_PORT	"123"			// NTP̃|[gԍ
#define	MY_PORT		"10000"			// NTPM|[gԍ

extern void waitTimer(int);
extern void setTimer(int);
extern int expiredTimer();
extern void print2ndLine(char *);
extern void startClock(unsigned char *);

// USARTʐM֌W ---------------------------------------------------------
char wifiReadReady()
{
	return ((UCSR0A & (1<<RXC0)) != 0);	// USARTɃf[^Ă邩ǂ
}

unsigned char wifiReadChar()
{
	while ((UCSR0A & (1<<RXC0)) == 0)	// f[^͂܂ő҂
		;	// [v̒ł͉sȂ
	return UDR0;	// Ԃ
}

void wifiWriteChar(char ch)
{
	while ((UCSR0A & (1<<UDRE0)) == 0 )	// o͉\ɂȂ܂ő҂
		;	// [v̒ł͉sȂ
	UDR0 = ch;	// o͂
}

unsigned char readBuff[BUFF_LEN];
// Wi-FiW['\0'ŏI镶𑗐M
int wifiSendCommand(char *cmd)
{
	int i;
	char *p = readBuff - 1;
	char *outP = cmd;

	// Wi-FiW[̕ԓi[obt@0Ŗ߂
	for ( i = 0; i < BUFF_LEN; i++ ) {
		readBuff[i] = '\0';
	}
	i = 0;	// ԓ̃JE^0
	while ( *outP != '\0' ) {
		wifiWriteChar(*outP++);	// 1o
		setTimer(10);		// Wi-FiW[Ԃɍ悤ɃEFCgݒ
		while ( !expiredTimer()) {
			while (i < BUFF_LEN && wifiReadReady()) {
				// EFCgłԓobt@ς܂Ŋi[
				i++;
				*++p = wifiReadChar();
			}
		}
	}
	// sR[hė邩Aobt@ӂ܂ŎMJԂ
	for ( ; i < BUFF_LEN && *p != LF; i++ ) {
		*++p = wifiReadChar();
	}
	// ԓ̐擪OKAR}hs
	if ( readBuff[0] == 'O' && readBuff[1] == 'K' )
		return TRUE;

	return FALSE;
}

// Wi-FiW[ɃoCif[^i0܂܂邩Ȃj𑗐M
int wifiSendByteCommand(char *cmd, int len)
{
	int i, j;
	char *p = readBuff - 1;
	char *outP = cmd;

	// Wi-FiW[̕ԓi[obt@0Ŗ߂
	for ( i = 0; i < BUFF_LEN; i++ ) {
		readBuff[i] = '\0';
	}
	j = 0;	// ԓ̃JE^0
	for ( i = 0; i < len; i++ ) {
		wifiWriteChar(*outP++);	// 1oCgo
		if (i == len - 1)
			break;			// Ō̕o͂Ƃ́AEFCgȂ
		setTimer(10);		// Wi-FiW[Ԃɍ悤ɃEFCgݒ
		while (!expiredTimer()) {
			while (j < BUFF_LEN && wifiReadReady()) {
				// EFCgłԓobt@ς܂Ŋi[
				j++;
				*++p = wifiReadChar();
			}
		}
	}
	// sR[hė邩Aobt@ӂ܂ŎMJԂ
	for ( ; j < BUFF_LEN && (j == 0 || *p != LF); j++ ) {
		*++p = wifiReadChar();
	}
	// ԓ̐擪OKAR}hs
	if ( readBuff[0] == 'O' && readBuff[1] == 'K' )
		return TRUE;

	return FALSE;
}

// UDP/IP pPbg̎M
int wifiReadPacket()
{
	int i;
	short len;
	unsigned char *p = readBuff;
	const char header[] = "AT+RSI_READ";

	setTimer(1000);		// 1bŃ^CAEg
	for ( i = 0; header[i] != '\0'; i++ ) {
		while (!wifiReadReady()) {
			if (expiredTimer())
				return FALSE;
		}
		if (wifiReadChar() != header[i]) {
			return FALSE;	// pPbgM̍}ȂΎs
		}
	}
	wifiReadChar();		// \Pbgԍǂݍ({vO̓\PbggȂ̂Ŕԍ͖)
	len = wifiReadChar() + wifiReadChar() * 0x100;	// f[^ǂݍ
	// T[oIPAhXƃ|[gԍĂ邪AʐM͌܂Ă̂œǂݎ̂Ă
	for ( i = 0; i < 6; i++ ) {
		wifiReadChar();
	}
	// pPbg{̂ǂݍ
	for ( i = 0; i < len; i++ ) {
		if ( i < UDP_BUFF_LEN) {
			*p++ = wifiReadChar();
		} else {
			wifiReadChar();
		}
	}
	// pPbg̒ɉsȂΎMs
	if ( wifiReadChar() != CR || wifiReadChar() != LF || len < UDP_BUFF_LEN ) {
		return FALSE;
	}
	return TRUE;
}


// USART̏
int wifiInitialize1()
{
	UBRR0H = 0;
	UBRR0L = 10;		// 115200 bps at 20MHz clock
	UCSR0B = 0x18;		// 2 stop bits
	UCSR0C = 0x0e;		// 8bit, non parity

	return TRUE;
}

// Wi-FiW[ƃ{[[gv
int wifiInitialize2()
{
	int loopFlag;

	loopFlag = TRUE;
	while (loopFlag) {
		waitTimer(200);		//  200ms ҂
		wifiWriteChar(0x1c);
		while ( wifiReadReady() ) {
			if ( wifiReadChar() == 0x55 )
				loopFlag = FALSE;	// {[[gv
		}
	}
	wifiWriteChar(0x55);	// Wi-FiW[Ƀ{[[g̈vm点

	return TRUE;
}

// ANZX|Cĝ̖vĂ邩ׂ֐
int essidFound(char *response, char *essid, int len)
{
	int i;

	for ( i = 0; i < len; i++ ) {
		if ( response[i] == CR )
			return FALSE;
		if ( response[i] != essid[i] )
			return FALSE;
	}
	return TRUE;
}

// NTPpPbg𑗂ĕԓ󂯎֐
int wifiInitialize3()
{
	int i, j;
	char c;
	char *p;
	char writeBuff[BUFF_LEN];
	char saveBuff[BUFF_LEN];
	char sock_handle;

	// ԓi[obt@0NA
	for ( i = 0; i < BUFF_LEN; i++ ) {
		readBuff[i] = 0;
	}

	print2ndLine("Skip firm load  ");	// t2sڂɃbZ[W
	// t@[EFAAbvf[gւ̉
	while ( (c = wifiReadChar()) == 0 || c == CR || c == LF )
		;	// [v̒ł͉Ȃ

	while ( wifiReadChar() != ')' )
		;	// [v̒ł͉Ȃ

	for ( i = 0; i < 3; i++ ) {
		while (wifiReadChar() != LF)
			;	// [v̒ł͉Ȃ
	}

	print2ndLine("Wi-Fi initialize");	// t2sڂɃbZ[W
	// Wi-FiW[\tgZbg
	if (!wifiSendCommand("at+rsi_reset\r\n"))
		return FALSE;
	// 2.4GHzтgp
	if (!wifiSendCommand("at+rsi_band=0\r\n"))
		return FALSE;
	// bandw̌̏
	if (!wifiSendCommand("at+rsi_init\r\n"))
		return FALSE;

	print2ndLine("Wi-Fi connecting");	// t2sڂɃbZ[W
	// ESSIDɈv閼OANZX|Cg܂Ń[v
	do {
		// ESSIDw肵đS`lXL
		wifiSendCommand("at+rsi_scan=0," ESSID "\r\n");
	} while (!essidFound(readBuff + 2, ESSID, ESSID_LEN));

	print2ndLine("Wi-Fi setting   ");	// t2sڂɃbZ[W
	// ANZX|CgʂăC^[lbgɐڑ̂ŁACtXgN`[hI
	if (!wifiSendCommand("at+rsi_network=INFRASTRUCTURE\r\n"))
		return FALSE;
#ifdef	WEP_KEY
	// WEP Í̏ꍇ
	if (!wifiSendCommand("at+rsi_psk=" WEP_KEY "\r\n"))
		return FALSE;

	if (!wifiSendCommand("at+rsi_authmode=1\r\n"))
		return FALSE;
#else
#ifdef	PSK
	// PSK Í̏ꍇ
	if (!wifiSendCommand("at+rsi_psk=" PSK "\r\n"))
		return FALSE;
#endif
	// ÍȂꍇ
	if (!wifiSendCommand("at+rsi_authmode=0\r\n"))
		return FALSE;
#endif
	// ANZX|Cgɐڑ
	if (!wifiSendCommand("at+rsi_join=" ESSID ",0,0\r\n"))
		return FALSE;

	print2ndLine("DHCP negotiating");	// t2sڂɃbZ[W
	// DHCPIPAhX擾
	for (i = 0; i < 3 && !wifiSendCommand("at+rsi_ipconf=1,0,0,0\r\n"); i++) {
		waitTimer(1000);
	}
	if ( i >= 3 )
		return FALSE;	// 3񃋁[vĂDHCPɎsꍇ

	print2ndLine("UDP setting     ");	// t2sڂɃbZ[W
	// UDPNTPT[oɑM鏀
	if (!wifiSendCommand("at+rsi_udp=" NTP_SERVER "," NTP_PORT "," MY_PORT "\r\n"))
		return FALSE;
	sock_handle = readBuff[2];
	// pPbgf[^NTPT[o֑M
	for (j = 0; j < 5; j++) {
		const char sendCmd1[] = "at+rsi_snd=";
		const char sendCmd2[] = ",48," NTP_SERVER "," NTP_PORT ",";
		print2ndLine("SNTP communicatin");	// t2sڂɃbZ[W
		p = writeBuff;
		for ( i = 0; sendCmd1[i] != '\0'; i++ ) {
			*p++ = sendCmd1[i];
		}
		*p++ = sock_handle + '0';
		for ( i = 0; sendCmd2[i] != '\0'; i++ ) {
			*p++ = sendCmd2[i];
		}
		*p++ = 0x23;					// SNTP pPbg̑1oCg
		for ( i = 1; i < UDP_BUFF_LEN; i++ ) {
			*p++ = '\0';				// SNTPpPbg̎c
		}
		*p++ = CR;
		*p++ = LF;
		if ( !wifiSendByteCommand(writeBuff, p - writeBuff) ) {
			// SNTPMɎsꍇ
			for ( i = 0; i < BUFF_LEN; i++ ) {
				saveBuff[i] = readBuff[i];		// G[Ԃ̑ޔ
			}
			goto ERR_END;
		}
		if (wifiReadPacket())
			break;	// 擾ɐ
		print2ndLine("SNTP missed      ");	// t2sڂɃbZ[W
		waitTimer(30000);	// 30b҂Ă烊gC
	}
	if (j >= 5) {
		goto ERR_END;
	}

	startClock(readBuff);	// ṽX^[g

	// \Pbg̃NA
	{
		char sendCmd[] = "at+rsi_cls=#\r\n";
		sendCmd[11] = sock_handle + '0';
		if (!wifiSendCommand(sendCmd)) {
			return FALSE;
		}
	}
	// ANZX|CgƂ̐ڑ
	return wifiSendCommand("at+rsi_disassoc\r\n");
	
ERR_END:
	// G[̏ꍇڑďI
	{
		char sendCmd[] = "at+rsi_cls=#\r\n";
		sendCmd[11] = sock_handle + '0';
		if (!wifiSendCommand(sendCmd)) {
			goto RESTORE_ERR;
		}
	}
	wifiSendCommand("at+rsi_disassoc\r\n");

RESTORE_ERR:
	for ( i = 0; i < BUFF_LEN; i++ ) {
		readBuff[i] = saveBuff[i];
	}
	return FALSE;
}
